unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ScktComp, StdCtrls;

type
  TForm1 = class(TForm)
    ServerSocket: TServerSocket;
    ClientSocket: TClientSocket;
    Button1: TButton;
    Memo1: TMemo;
    Edit_Msg: TEdit;
    Edit_Name: TEdit;
    StatusBar1: TStatusBar;
    procedure KeyPressLimit(Sender: TObject; var Key: Char);
    procedure KeyPressLimit2(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Edit_MsgKeyPress(Sender: TObject; var Key: Char);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private 錾 }
  public
    { Public 錾 }
    
    IsServer : Boolean; // ʐM[h True=T[o False=NCAg
  end;

var
  Form1: TForm1; 

implementation

uses Mode;

{$R *.dfm}

procedure TForm1.KeyPressLimit(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #08]) then // ̓L['0'`'9',BackSpace/Delete ȊOȂ
  begin 
    beep;
    Key := #0; // ͂𖳎
  end;
end;

procedure TForm1.KeyPressLimit2(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', '.', #08]) then // ̓L['0'`'9','.',BackSpace/Delete ȊOȂ
  begin
    beep;
    Key := #0; // ͂𖳎
  end;
end; // IPAhX͗p'.'ǉB

procedure TForm1.Button1Click(Sender: TObject); // ڑ/ؒf{^Ƃ
begin
  if ClientSocket.Active then // NCAg[hŐڑȂ
  begin
    ClientSocket.Close; // NCAg[h̒ʐM
    StatusBar1.Panels[0].Text := 'Disconnect';
    Button1.Caption := 'Connect';
  end
  else if ServerSocket.Active then // T[o[hŐڑȂ
  begin
    ServerSocket.Close; // T[o[h̒ʐM
    StatusBar1.Panels[0].Text := 'Disconnect';
    Button1.Caption := 'Connect';
  end
  else // ڑԂȂ
    Form2.Visible := True; // ڑݒ_CAOĂяo
end;

procedure TForm1.Edit_MsgKeyPress(Sender: TObject; var Key: Char);
var // bZ[W͗ɃL[͂Ƃ
  str : String;
  i   : Integer;
begin
  if Key = #13 then // ̓L[Enteȑꍇ
  begin
    str := Edit_Name.Text + ' : ' + Edit_Msg.Text; // bZ[WɔҖǉ

    if IsServer then // T[o[hȂ
    begin
      Memo1.Lines.Add(str);  // g̃bZ[W\
      for i := 0 to ServerSocket.Socket.ActiveConnections - 1 do
        ServerSocket.Socket.Connections[i].SendText(str); // SNCAgɑM
    end
    else             // NCAg[hȂ
      ClientSocket.Socket.SendText(str); // T[oɃbZ[WM

    Edit_Msg.Text := ''; // MbZ[W͏
  end;
end;

procedure TForm1.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add(Socket.ReceiveText); // T[oMbZ[W\
end;

procedure TForm1.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  str : String;
  i   : Integer;
begin
  str := Socket.ReceiveText;
  Memo1.Lines.Add(str); // NCAgMbZ[W\

  for i := 0 to ServerSocket.Socket.ActiveConnections - 1 do // MbZ[W
    ServerSocket.Socket.Connections[i].SendText(str); // SNCAgɑM
end;

procedure TForm1.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  if ErrorEvent = eeConnect then // T[oɐڑłȂꍇ
  begin
    beep;
    MessageDlg(#13 + 'ڑł܂łB', mtError, [mbOk], 0);
  end;

  ErrorCode := 0; // ȏ̃G[\}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  IsServer := False;
end;

procedure TForm1.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.Panels[0].Text := 'Client Mode';
  Button1.Caption := 'Disconnect'; // ڑ\ύX
end;

procedure TForm1.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
    StatusBar1.Panels[0].Text := 'Disconnect';
    Button1.Caption := 'Connect'; // 炩̗RŐؒf\ύX
end;

end.
